package processModel;

import java.awt.Graphics2D;
import java.awt.Point;
import java.util.Observer;

/**
 * @author Kon Zakharov, k.zakharov@cosc.canterbury.ac.nz
 *
 */
public interface Element extends Observer{
	
	public void label(String l);
	public void paint(Graphics2D g2);
	public void setOrigin(Point p);
	public void setBeginPoint(Point p);
	public void setEndPoint(Point p);
	public String toString();
	//public List <Handle> getHandles();
	public void prepareForDeletion();
	
	// setters
	public void delta(String delta);
	public void select(boolean b);

	// Accessors
	
	public String delta();
	public String label();
	public boolean selected ();
	
	//Point Locations
	public Handle pointIsInHandle(Point p);
	public Element pointIsInElement(Point p);
	
    // Return XML representation of self
    public String toXML(String indent);
    public String toASPIRE_XML(String indent);
	
}